;Liste des pices 
Enumeration 
  #Vide          ; Perdu si une partie du joueur se trouve dans le vide
  #Sol           ; 
  #Sortie        ; Il faut tre  la verticale pour finir le niveau
  #InterSouple   ; Il suffit de passer dessus pour actionner cet interrupteur
  #InterDur      ; Il faut tre  la verticale pour actionner cet interrupteur
  #PontGauche    ; La charnire est  gauche , donc ajoute une dalle  droite
  #PontDroit     ; La charnire est  droite , donc ajoute une dalle  gauche  
  #SolOrange     ; Il faut se coucher sinon a casse !
  #InterDouble   ; Coupe le retangle en deux cubes
  #PontHaut
  #PontBas
  #Player 
  #Player2
EndEnumeration

Enumeration 
  #Cube
  #Rectangle
EndEnumeration

;- Structures des blocs 

Structure s_Vertex
  px.f
  py.f
  pz.f
  nx.f
  ny.f
  nz.f
  u.f
  v.f
EndStructure

Structure s_Camera
  Pos.f_Vecteur
  LookAt.f_Vecteur
EndStructure

Macro CREATE_MESH(Type)
  Mesh(Type)=CreateMesh(#PB_Any, 1)
  Options = #PB_Mesh_Vertex | #PB_Mesh_Normal |  #PB_Mesh_UVCoordinate  
  SetMeshData(Mesh(Type), Options      , ?Sommets  , 24)
  SetMeshData(Mesh(Type), #PB_Mesh_Face, ?Triangles, 12)
EndMacro

Macro CREATE_MATERIAL(Type, Couleur)
  Tx = 128
  Ty = 128
  Select Type
    Case #Sol
      Texture(Type)=LoadTexture(#PB_Any,"Sol.jpg")
      StartDrawing(TextureOutput(Texture(Type)))
        DrawingMode(#PB_2DDrawing_Outlined) 
        Box(0, 0, TextureWidth(Texture(Type)), TextureHeight(Texture(Type)), 0)
        Box(1, 1, TextureWidth(Texture(Type))-2, TextureHeight(Texture(Type))-2, $222222)
      StopDrawing() 
    Case #Sortie
      Texture(Type)=LoadTexture(#PB_Any,"Sortie.jpg")    
    Case #PontDroit,#PontGauche,#PontHaut,#PontBas
      Texture(Type)=LoadTexture(#PB_Any,"Pont.jpg")
    Case #InterSouple
      Texture(Type)=LoadTexture(#PB_Any,"InterSouple.jpg")
    Case #InterDur
      Texture(Type)=LoadTexture(#PB_Any,"InterDur.jpg")
    Case #InterDouble
      Texture(Type)=LoadTexture(#PB_Any,"InterDouble.jpg")
    Case #Player
      Texture(Type)=CreateTexture(#PB_Any, Tx, Ty)
      StartDrawing(TextureOutput(Texture(Type)))
        Box(0, 0, Tx, Ty, Couleur)
        DrawingMode(#PB_2DDrawing_Outlined) 
        Box(0, 0, TextureWidth(Texture(Type)), TextureHeight(Texture(Type)), $999999)
      StopDrawing() 
    Case #Player2
      Texture(Type)=CreateTexture(#PB_Any, Tx, Ty)
      StartDrawing(TextureOutput(Texture(Type)))
        Box(0, 0, Tx, Ty, Couleur)
        DrawingMode(#PB_2DDrawing_Outlined) 
        Box(0, 0, TextureWidth(Texture(Type)), TextureHeight(Texture(Type)), $999999)
      StopDrawing()         
    Default
      Texture(Type)=CreateTexture(#PB_Any, Tx, Ty)
      StartDrawing(TextureOutput(Texture(Type)))
        Box(0, 0, Tx, Ty, Couleur)
        DrawingMode(#PB_2DDrawing_Outlined) 
        Box(0, 0, TextureWidth(Texture(Type)), TextureHeight(Texture(Type)), 0)
        Box(1, 1, TextureWidth(Texture(Type))-2, TextureHeight(Texture(Type))-2, $222222)
      StopDrawing()      
  EndSelect    

  Material(Type)=CreateMaterial(#PB_Any, TextureID(Texture(Type)))
  
  Select Type
    Case #Player
      MaterialBlendingMode(Material(#Player),#PB_Material_Color)
      DisableMaterialLighting(Material(#Player), 1)
    Case #Player2
      ;MaterialBlendingMode(Material(#Player2),#PB_Material_Color)
      DisableMaterialLighting(Material(#Player2), 1)
    Case #Sortie  
      RotateMaterial(Material(#Sortie),0.1,#PB_Material_Animated)
    Case #Sol
      ;MaterialBlendingMode(Material(#SolOrange),#PB_Material_Color)
      ;MaterialDiffuseColor(Material(#SolOrange),RGB(255,255,0))
      ;DisableMaterialLighting(Material(#Sol), 0)      
  EndSelect  
EndMacro

Macro NEW_X(x, Angle, Distance) 
  ((x) + Cos((Angle) * 0.0174533) * (Distance))
EndMacro

Macro NEW_Z(z, Angle, Distance)
  ((z) - Sin((Angle) * 0.0174533) * (Distance))
EndMacro

;-Camera
#Camera = 0
CreateCamera(#Camera, 0, 0, 100, 100)
CameraFOV(#Camera,#Focale*#PI/180)
;CameraProjection(#Camera,#PB_Camera_Orthographic)
 
;-Light
AmbientColor(RGB(185,185,185))
CreateLight(0,$FFFFFF,500,500,500)

;-SkyBox
SkyBox("stevecube.jpg")

;-Dim
Global Dim Mesh(#Player2)
Global Dim Texture(#Player2)
Global Dim Material(#Player2)
Global Camera.s_Camera

Camera\Pos\x = 65
Camera\Pos\y = 120
Camera\Pos\z = 200
Camera\LookAt\x = 8*#Taille
Camera\LookAt\y = -50
Camera\LookAt\z = 5*#Taille
  
;-Declare
Declare MakeMesh(*Player.s_Player)
Declare MakePont(Entity, Type, Sens, *p.f_Vecteur)
Declare InitMesh()
Declare InitMaterial()
Declare.f CurveValue(actuelle.f, Cible.f, P.f) 
Declare GestionCamera(*M.Point)
;-DataSection
;{-Dfinition du cube
DataSection
Sommets:
;Dessus 0  3
Data.f -0.5,0.5,-0.5
Data.f 0,1,0
Data.f 0,0

Data.f 0.5,0.5,-0.5
Data.f 0,1,0
Data.f 0,1

Data.f 0.5,0.5,0.5
Data.f 0,1,0
Data.f 1,1

Data.f -0.5,0.5,0.5
Data.f 0,1,0
Data.f 1,0

;Dessous 4  7
Data.f -0.5,-0.5,0.5
Data.f 0,-1,0
Data.f 0,0

Data.f 0.5,-0.5,0.5
Data.f 0,-1,0
Data.f 0,1

Data.f 0.5,-0.5,-0.5
Data.f 0,-1,0
Data.f 1,1

Data.f -0.5,-0.5,-0.5
Data.f 0,-1,0
Data.f 1,0

;Devant 8  11
Data.f -0.5,0.5,0.5
Data.f 0,0,1
Data.f 0,0

Data.f 0.5,0.5,0.5
Data.f 0,0,1
Data.f 0,1

Data.f 0.5,-0.5,0.5
Data.f 0,0,1
Data.f 1,1

Data.f -0.5,-0.5,0.5
Data.f 0,0,1
Data.f 1,0

;Derrire 12  15
Data.f 0.5,0.5,-0.5
Data.f 0,0,-1
Data.f 0,0

Data.f -0.5,0.5,-0.5
Data.f 0,0,-1
Data.f 0,1

Data.f -0.5,-0.5,-0.5
Data.f 0,0,-1
Data.f 1,1

Data.f 0.5,-0.5,-0.5
Data.f 0,0,-1
Data.f 1,0

;Cote gauche 16  19
Data.f -0.5,0.5,-0.5
Data.f -1,0,0
Data.f 0,0

Data.f -0.5,0.5,0.5
Data.f -1,0,0
Data.f 0,1

Data.f -0.5,-0.5,0.5
Data.f -1,0,0
Data.f 1,1

Data.f -0.5,-0.5,-0.5
Data.f -1,0,0
Data.f 1,0

;Cote droit 20  23
Data.f 0.5,0.5,0.5
Data.f 1,0,0
Data.f 0,0

Data.f 0.5,0.5,-0.5
Data.f 1,0,0
Data.f 0,1

Data.f 0.5,-0.5,-0.5
Data.f 1,0,0
Data.f 1,1

Data.f 0.5,-0.5,0.5
Data.f 1,0,0
Data.f 1,0

Triangles:
;Face en Haut
Data.w 2,1,0
Data.w 0,3,2
;Face en Bas
Data.w 6,5,4
Data.w 4,7,6
;Face Avant
Data.w 10,9,8
Data.w 8,11,10
;Face Arrire
Data.w 14,13,12
Data.w 12,15,14
;Face Gauche
Data.w 18,17,16
Data.w 16,19,18
;Face Droite 
Data.w 22,21,20
Data.w 20,23,22
EndDataSection
;}
; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 55
; FirstLine = 47
; Folding = --