XIncludeFile "Game.pbi"
Procedure LoadSounds()
  Define i
  Define.s Sound
  Restore Sons
  For i = #Sound_Open To #Sound_Exit
    Read Sound
    If LoadSound(i,"Sounds\"+Sound)=0
      MessageRequester("Erreur", "Impossible de charger le fichier " + "Sounds\"+Sound,0)
      End
    EndIf   
  Next i
EndProcedure

Procedure GestionClavier(*Map.s_Map, *Player.s_Player)
  Define Temp
  Static ToucheSpace
  ;If ExamineKeyboard()  
  
    If *Player\Sens = #Vertical ; Le joueur est  l'arrt
      If GetKeyState_(#VK_LEFT) & $80;KeyboardPushed(#PB_Key_Left) 
        *Player\Sens = #Ouest : MakeMesh(*Player)
      ElseIf GetKeyState_(#VK_RIGHT) & $80;KeyboardPushed(#PB_Key_Right) 
        *Player\Sens = #Est   : MakeMesh(*Player)
      ElseIf GetKeyState_(#VK_UP) & $80;KeyboardPushed(#PB_Key_Up) 
        *Player\Sens = #Nord  : MakeMesh(*Player)
      ElseIf GetKeyState_(#VK_DOWN) & $80;KeyboardPushed(#PB_Key_Down) 
        *Player\Sens = #Sud   : MakeMesh(*Player)
      ElseIf ToucheSpace=#False And *Player\Taille=#Cube And GetKeyState_(#VK_SPACE) & $80;KeyboardReleased(#PB_Key_Space)
        ToucheSpace = #True
        ; Bascule entre les deux cubes, le cube actif pourra tre dplac
        With *Player
        \p\x=\p2\x
        \p\z=\p2\z
        \p2\x=\Bloc1\x*#Taille
        \p2\z=\Bloc1\z*#Taille
        Temp=*Player\Toggle1
        *Player\Toggle1=*Player\Toggle2
        *Player\Toggle2=Temp
        MakeMesh(*Player)
        EntityLocate(\Entity2, \p2\x, \p2\y, \p2\z)
        EndWith
      ElseIf GetKeyState_(#VK_SPACE) & $80=0
        ToucheSpace = #False  
      EndIf
      ;Mmoire pour les rotations quand on perd ,  revoir
      MemSens=*Player\Sens
    EndIf
  ;EndIf
EndProcedure
Procedure CloseBloc(*Map.s_Map,x,z)
  Define.f Delta
  
  Delta = *Map\Vitesse*CoefSelonFPS

  If x<>0 
    DataMap(x,z)\c + Delta
    If DataMap(x,z)\Type=#PontGauche 
      DataMap(x,z)\Angle + Delta
      RotateEntity(DataMap(x,z)\Entity,0,0,DataMap(x,z)\Angle)  
    ElseIf DataMap(x,z)\Type=#PontDroit
      DataMap(x,z)\Angle - Delta
      RotateEntity(DataMap(x,z)\Entity,0,0,DataMap(x,z)\Angle)  
    ElseIf DataMap(x,z)\Type=#PontHaut
      DataMap(x,z)\Angle - Delta
      RotateEntity(DataMap(x,z)\Entity,0,DataMap(x,z)\Angle,0) 
    ElseIf DataMap(x,z)\Type=#PontBas
      DataMap(x,z)\Angle + Delta
      RotateEntity(DataMap(x,z)\Entity,0,DataMap(x,z)\Angle,0) 
    EndIf
    If DataMap(x,z)\c>=90 
      DataMap(x,z)\c=0
      DataMap(x,z)\Angle = 0
      DataMap(x,z)\Etat = #Close
      PlaySound(#Sound_Close,2)

      If DataMap(x,z)\Type=#PontGauche Or DataMap(x,z)\Type=#PontDroit
        RotateEntity(DataMap(x,z)\Entity,0,0,DataMap(x,z)\Angle) 
      Else
        RotateEntity(DataMap(x,z)\Entity,0,DataMap(x,z)\Angle,0)
      EndIf
      ProcedureReturn #True
    EndIf
  EndIf
EndProcedure
Procedure OpenBloc(*Map.s_Map,x,z)
  Define.f Delta

  Delta = *Map\Vitesse*CoefSelonFPS

  If x<>0 
    DataMap(x,z)\c + Delta
    If DataMap(x,z)\Type=#PontGauche 
      DataMap(x,z)\Angle - Delta
      RotateEntity(DataMap(x,z)\Entity,0,0,DataMap(x,z)\Angle)  
    ElseIf DataMap(x,z)\Type=#PontDroit
      DataMap(x,z)\Angle + Delta
      RotateEntity(DataMap(x,z)\Entity,0,0,DataMap(x,z)\Angle)  
    ElseIf DataMap(x,z)\Type=#PontHaut
      DataMap(x,z)\Angle + Delta
      RotateEntity(DataMap(x,z)\Entity,0,DataMap(x,z)\Angle,0) 
    ElseIf DataMap(x,z)\Type=#PontBas
      DataMap(x,z)\Angle - Delta
      RotateEntity(DataMap(x,z)\Entity,0,DataMap(x,z)\Angle,0) 
    EndIf
    If DataMap(x,z)\c>=90
      DataMap(x,z)\c=0
      DataMap(x,z)\Etat = #Open
      PlaySound(#Sound_Open,2)
      ProcedureReturn #True
    EndIf      
  EndIf

EndProcedure
Procedure AnimationEvent(*Map.s_Map)
  Define k, Fin
  Define.s_Event *Ptr
  
  ForEach AnimEvent()
      
    *Ptr=AnimEvent()\Event
    
    Select *Ptr\Type
    
      Case #Open
        Fin=#False
        If DataMap(*Ptr\Bloc\x,*Ptr\Bloc\z)\Etat=#Close
          Fin = OpenBloc(*Map,*Ptr\Bloc\x,*Ptr\Bloc\z)
        Else
          Fin = #True
        EndIf  

      Case #Close
        Fin=#False
        If DataMap(*Ptr\Bloc\x,*Ptr\Bloc\z)\Etat=#Open
          Fin = CloseBloc(*Map,*Ptr\Bloc\x,*Ptr\Bloc\z)
        Else
          Fin = #True  
        EndIf

      Case #Toggle
        Fin=#False
        If DataMap(*Ptr\Bloc\x,*Ptr\Bloc\z)\Etat=#Open
          Fin = CloseBloc(*Map,*Ptr\Bloc\x,*Ptr\Bloc\z)
        ElseIf DataMap(*Ptr\Bloc\x,*Ptr\Bloc\z)\Etat=#Close
          Fin = OpenBloc(*Map,*Ptr\Bloc\x,*Ptr\Bloc\z)
        Else
          Fin=#True
        EndIf

    EndSelect 
    
    *Ptr=*Ptr\Next
 
    If Fin  
      DeleteElement(AnimEvent())
    EndIf 
    
  Next  
EndProcedure
Procedure DoEvent(*Map.s_Map, *Player.s_Player, x, z)
  Define k, Tombe, Type
  Define.s_Event *Ptr

  If *Player\Toggle1 = #False
    
    *Ptr=Event(x,z)\Event
    
    For k=1 To Event(x,z)\NbEvent
    
      Select *Ptr\Type
     
        Case #Open, #Close, #Toggle
          ADD_ANIM_EVENT() 
   
        Case #Teleporte ; Grer une lib vnement <-- Il s'agit ici d'un autre type d'vnement 
          If k=1
            PlaySound(#Sound_Switch)
          EndIf
          TELEPORTATION()

      EndSelect   
    
      *Ptr = *Ptr\Next 
    
    Next k
  
  EndIf
  
  ;Au moins une animation en cours   
  If CountList(AnimEvent())
    *Player\Toggle1 = #True
  EndIf
  
EndProcedure
Procedure InitEvent(*Map.s_Map)
  Define i, j, k
  Define.s_Event *Ptr, *Suivant
  
  For j=1 To #MaxMapZ
    For i=1 To #MaxMapX
      If Event(i,j)\NbEvent  
        *Ptr = Event(i,j)\Event
        For k=1 To Event(i,j)\NbEvent 
          *Suivant = *Ptr\Next
          FreeMemory(*Ptr)
          Event(i,j)\Event=#Null
          *Ptr = *Suivant
        Next k
        Event(i,j)\NbEvent=0
      EndIf
    Next i
  Next j  
EndProcedure
Procedure LoadEvent(*Map.s_Map)
  Define.s Fichier
  Define.l i,j,k
  Define.s_Event *Ptr
  Fichier="Event\Niveau"+Str(*Map\Level)+".Event"
  If ReadFile(0, Fichier)
    For j=1 To *Map\SizeZ
      For i=1 To *Map\SizeX
        Event(i,j)\NbEvent=ReadLong(0)
        If Event(i,j)\NbEvent  
          Event(i,j)\Event=AllocateMemory(SizeOf(s_event))
          *Ptr=Event(i,j)\Event
          For k=1 To Event(i,j)\NbEvent
            *PTr\Type=ReadLong(0)
            *Ptr\Bloc\x=ReadLong(0)
            *Ptr\Bloc\z=ReadLong(0)
            If k=Event(i,j)\NbEvent
              *Ptr\Next=#Null
            Else
              *Ptr\Next=AllocateMemory(SizeOf(s_Event))
            EndIf  
            *Ptr=*Ptr\Next
          Next k
        EndIf
      Next i
    Next j  
    CloseFile(0)  
  Else
    MessageErreur( "Impossible de charger " + Fichier)
  EndIf
  
EndProcedure
Procedure EnregistreEvent(*Map.s_Map)
  Define i,j,k
  Define.s_Event *Ptr
  If CreateFile(0,"Event\Niveau"+Str(*Map\Level)+".Event")

    For j=1 To *Map\SizeZ 
      For i=1 To *Map\SizeX
        WriteLong(0, Event(i,j)\NbEvent)
        If Event(i,j)\NbEvent
          *Ptr = Event(i,j)\Event
          For k=1 To Event(i,j)\NbEvent
            WriteLong(0, *Ptr\Type)
            WriteLong(0, *Ptr\Bloc\x)
            WriteLong(0, *Ptr\Bloc\z)
            *Ptr=*Ptr\Next
          Next k
        EndIf         
      Next i
    Next j    
    CloseFile(0)
  EndIf
  
EndProcedure   
Procedure IndexArrayOk(*Map.s_map,x,z)
  If x > 0 And z > 0 And x <= *Map\SizeX And z <= *Map\SizeZ
    ProcedureReturn #True
  EndIf
EndProcedure
Procedure Perdu(*Map.s_Map, *Player.s_Player)
  Define i, j
  Define.f Vitesse, Tombe
  Vitesse = -3*CoefSelonFPS
  Tombe = 96
  *Map\MoveTmp = 0
  If *Player\Taille=#Rectangle
    If IndexArrayOk(*Map,*Player\Bloc1\x,*Player\Bloc1\z) And IsEntity(DataMap(*Player\Bloc1\x,*Player\Bloc1\z)\entity)
      PlaySound(#SOUND_CRUSH77,2)
    EndIf
    If IndexArrayOk(*Map,*Player\Bloc2\x,*Player\Bloc2\z) And IsEntity(DataMap(*Player\Bloc2\x,*Player\Bloc2\z)\entity)
      PlaySound(#SOUND_CRUSH77,2)
    EndIf  
  EndIf
  
  PlaySound(#Sound_BATHOS,2)
  Repeat 
    tombe - 2*CoefSelonFPS
    MoveEntity(*Player\Entity, 0, Vitesse, 0)
    MoveEntity(*Player\Entity2, 0, Vitesse, 0)
    If IndexArrayOk(*Map,*Player\Bloc1\x,*Player\Bloc1\z) And IsEntity(DataMap(*Player\Bloc1\x,*Player\Bloc1\z)\entity)
      MoveEntity(DataMap(*Player\Bloc1\x,*Player\Bloc1\z)\entity, 0, Vitesse, 0)
    EndIf
    If IndexArrayOk(*Map,*Player\Bloc2\x,*Player\Bloc2\z) And IsEntity(DataMap(*Player\Bloc2\x,*Player\Bloc2\z)\entity)
      MoveEntity(DataMap(*Player\Bloc2\x,*Player\Bloc2\z)\entity, 0, Vitesse, 0)
    EndIf

    RenderWorld()
    AFFICHE_INFORMATIONS(*Map\Level,*Map\Move,*Map\MoveTmp)
    FlipBuffers()  
  Until Tombe <= 0  
    HideEntity(*Player\Entity, 1)
    HideEntity(*Player\Entity2, 1)
  Tombe = 180  
  Repeat 
    tombe - 2*CoefSelonFPS
    For j=1 To *Map\SizeZ
      For i=1 To *Map\SizeX  
        If IsEntity(DataMap(i,j)\Entity)
          MoveEntity(DataMap(i,j)\Entity,0,DataMap(i,j)\Random\y*CoefSelonFPS,0)
        EndIf  
      Next i
    Next j  
    RenderWorld()
    AFFICHE_INFORMATIONS(*Map\Level,*Map\Move,*Map\MoveTmp)
    FlipBuffers()    
  Until Tombe <= 0 

  CHARGE_MAP()  

EndProcedure
Procedure Gagne(*Map.s_Map, *Player.s_Player)
  Define No, Dx, Dz, P,i, j
  Define.f Tombe
  ;Mise  jour du compteur Mouvement.
  *Map\Move + *Map\MoveTmp
  *Map\MoveTmp = 0
  
  PlaySound(#SOUND_NEONBELL,2)
 
  Tombe = 100  
  
  Repeat 
    tombe - CoefSelonFPS
    P=#Taille*2
    For j=1 To *Map\SizeZ
      For i=1 To *Map\SizeX  
        If IsEntity(DataMap(i,j)\Entity)
          
          ;Gestion de l'empilage des blocs
          P - 2
          If p<0
            P=#Taille*2
          EndIf  
                    
          ;Recentre les blocs qui sont dcals (axe de rotation non centr)
          If DataMap(i,j)\Type=#PontBas
            Dx=0
            Dz=-#Taille2
          ElseIf DataMap(i,j)\Type=#PontHaut
            Dx=0
            Dz=#Taille2          
          ElseIf DataMap(i,j)\Type=#PontGauche
            Dx=-#Taille2
            Dz=0
          ElseIf DataMap(i,j)\Type=#PontDroit
            Dx=#Taille2
            Dz=0
          Else
            Dx=0
            Dz=0
          EndIf
          
          No=DataMap(i,j)\Entity
          EntityLocate(No,Curvevalue(EntityX(No),Dx+*Player\Bloc1\x*#Taille,80*CoefSelonFPS),EntityY(*Player\Entity)+p,Curvevalue(EntityZ(No),Dz+*Player\Bloc1\z*#Taille,80*CoefSelonFPS))
        EndIf  
      Next i
    Next j  
    MoveEntity(*Player\Entity, 0, -3*CoefSelonFPS, 0)
    RenderWorld()
    AFFICHE_INFORMATIONS(*Map\Level,*Map\Move,*Map\MoveTmp)
    FlipBuffers()    
  Until Tombe <= 0 
  
  CHARGE_MAP()
EndProcedure

Procedure ControleJeu(*Map.s_Map, *Player.s_Player)
  Define.l i, j, k
  
  ;Mise  jour des blocs occupes par le joueur
  Select *Player\Type
    Case #Nord, #Sud
      POSITION_NORD_SUD()
    Case #Est, #Ouest
      POSITION_EST_OUEST()
    Case #Vertical
      POSITION_VERTICALE()
  EndSelect 
   
  ;Test si les deux cubes sont cte  cte
  With *Player
  If \Taille=#Cube
    If \Bloc1\x=\Bloc2\x And \Bloc1\z-1=\Bloc2\z 
      \Type=#Nord
      \Taille=#Rectangle
      \p\z-0.5*#Taille
    ElseIf \Bloc1\x=\Bloc2\x And \Bloc1\z+1=\Bloc2\z  
      \Type=#Sud
      \Taille=#Rectangle
      \p\z+0.5*#Taille
    ElseIf \Bloc1\z=\Bloc2\z And \Bloc1\x-1=\Bloc2\x 
      \Type=#Ouest
      \Taille=#Rectangle
      \p\x-0.5*#Taille
    ElseIf \Bloc1\z=\Bloc2\z And \Bloc1\x+1=\Bloc2\x  
      \Type=#Est
      \Taille=#Rectangle 
      \p\x+0.5*#Taille
    EndIf  
    If \Taille=#Rectangle
      HideEntity(\Entity2,1)
      MakeMesh(*Player)
    EndIf  
  EndIf
  EndWith 
  
  ;Test si le joueur est en dehors du tableau du jeu      
  TEST_OUT(*Player\Bloc1\x,*Player\Bloc1\z,*Player\Bloc2\x,*Player\Bloc2\z)
        
  If *Player\out  
    Perdu(*Map.s_Map, *Player.s_Player)
  ElseIf *Player\type = #Vertical 
    ;Lorsqu'il y a deux cubes , il est possible que le deuxime soit sur un pont qui s'ouvre !
    If DataMap(*Player\Bloc2\x,*Player\Bloc2\z)\Etat<>#Close 
      Perdu(*Map.s_Map, *Player.s_Player)
    EndIf
    Select DataMap(*Player\Bloc1\x,*Player\Bloc1\z)\type 
      Case #Sortie
        If *Player\Taille=#Rectangle
          PlaySound(#Sound_Exit)
          *Map\Level + 1
          Gagne(*Map.s_Map, *Player.s_Player)   
        EndIf
      Case #PontDroit, #PontGauche,#PontHaut,#PontBas
        SOUND_MAP(#Sound_Metal)
        If DataMap(*Player\Bloc1\x,*Player\Bloc1\z)\Etat<>#Close 
          Perdu(*Map.s_Map, *Player.s_Player)
        EndIf 
      Case #InterSouple
        DoEvent(*Map, *Player, *Player\Bloc1\x,*Player\Bloc1\z)
      Case #InterDur
        If *Player\Taille=#Rectangle
          DoEvent(*Map, *Player, *Player\Bloc1\x,*Player\Bloc1\z)
        EndIf  
      Case #SolOrange 
        If *Player\Taille=#Rectangle
          Perdu(*Map.s_Map, *Player.s_Player)  
        EndIf 
      Case #InterDouble
        If *Player\Taille=#Rectangle
          DoEvent(*Map, *Player, *Player\Bloc1\x,*Player\Bloc1\z)
        EndIf
      Default
        SOUND_MAP(#Sound_Wood)
  
    EndSelect
  Else 
    
    Select DataMap(*Player\Bloc1\x,*Player\Bloc1\z)\type 
      Case #PontDroit, #PontGauche,#PontHaut,#PontBas
        SOUND_MAP(#Sound_Metal)
        If DataMap(*Player\Bloc1\x,*Player\Bloc1\z)\Etat<>#Close
          Perdu(*Map.s_Map, *Player.s_Player)
        EndIf 
      Case #InterSouple
        DoEvent(*Map, *Player, *Player\Bloc1\x,*Player\Bloc1\z)
      Default
        SOUND_MAP(#Sound_Wood1)
    EndSelect   
    
    Select DataMap(*Player\Bloc2\x,*Player\Bloc2\z)\type 
      Case #PontDroit, #PontGauche,#PontHaut,#PontBas
        SOUND_MAP(#Sound_Metal)
        If DataMap(*Player\Bloc2\x,*Player\Bloc2\z)\Etat<>#Close
          Perdu(*Map.s_Map, *Player.s_Player)
        EndIf 
      
      Case #InterSouple
        DoEvent(*Map, *Player, *Player\Bloc2\x,*Player\Bloc2\z)
             
    EndSelect   
  EndIf  
EndProcedure
Procedure Animation(*Map.s_map, *Player.s_Player)
  Define.f Vitesse, Scale

  Vitesse = *Player\Vitesse*CoefSelonFPS

  If *Player\Taille = #Cube
    Scale = 1.0
  Else
    Scale = 1.5
  EndIf  
    
  Select *Player\Sens 

    Case #Ouest
      *Player\Angle + Vitesse
      If *Player\Angle > 90 : *Player\Angle = 90 : EndIf  
      RotateEntity(*Player\Entity,0,0,*Player\Angle)
      
      If Int(*Player\Angle) = 90
        *Player\Angle = 0 : *Player\Sens = #Vertical
        *Player\Toggle1 = #False : *Map\SoundToggle = #False : *Map\MoveTmp + 1
        If *Player\Type = #Vertical And *Player\Taille = #Rectangle
          *Player\Type = #Ouest
          *Player\p\x - Scale*#Taille
        ElseIf *Player\Type = #Est Or *Player\Type = #Ouest
          *Player\Type = #Vertical
          *Player\p\x - Scale*#Taille
        Else  
          *Player\p\x - #Taille
        EndIf
        
      EndIf
        
    Case #Est
      *Player\Angle - Vitesse
      If *Player\Angle < -90 : *Player\Angle = -90 : EndIf 
      RotateEntity(*Player\Entity,0,0,*Player\Angle)
      If Int(*Player\Angle) = -90
        *Player\Angle = 0 : *Player\Sens = #Vertical
        *Player\Toggle1 = #False : *Map\SoundToggle = #False : *Map\MoveTmp + 1 
        If *Player\Type = #Vertical And *Player\Taille = #Rectangle
          *Player\Type = #Est
          *Player\p\x + Scale*#Taille
        ElseIf *Player\Type = #Est Or *Player\Type = #Ouest
          *Player\Type = #Vertical
          *Player\p\x + Scale*#Taille
        Else
          *Player\p\x + #Taille  
        EndIf
        
      EndIf   
       
    Case #Nord
      *Player\Angle - Vitesse
      If *Player\Angle < -90 : *Player\Angle = -90 : EndIf 
      RotateEntity(*Player\Entity,0,*Player\Angle,0)
  
      If Int(*Player\Angle) = -90
        *Player\Angle = 0 : *Player\Sens = #Vertical
        *Player\Toggle1 = #False : *Map\SoundToggle = #False : *Map\MoveTmp + 1
        If *Player\Type = #Vertical And *Player\Taille = #Rectangle
          *Player\Type = #Nord
          *Player\p\z - Scale*#Taille
        ElseIf *Player\Type = #Nord Or *Player\Type = #Sud
          *Player\Type = #Vertical
          *Player\p\z - Scale*#Taille
        Else
          *Player\p\z - #Taille  
        EndIf 
        
      EndIf
              
    Case #Sud
      *Player\Angle + Vitesse
      If *Player\Angle > 90 : *Player\Angle = 90 : EndIf 
      RotateEntity(*Player\Entity,0,*Player\Angle,0)
      If Int(*Player\Angle) = 90
        *Player\Angle = 0 :  *Player\Sens = #Vertical
        *Player\Toggle1 = #False : *Map\SoundToggle = #False : *Map\MoveTmp + 1
        If *Player\Type = #Vertical And *Player\Taille = #Rectangle
          *Player\Type = #Sud
          *Player\p\z + Scale*#Taille
        ElseIf *Player\Type = #Nord Or *Player\Type = #Sud
          *Player\Type = #Vertical
          *Player\p\z + Scale*#Taille
        Else
          *Player\p\z + #Taille  
        EndIf  
  
      EndIf  
  
  EndSelect  
  
EndProcedure

DataSection
Sons:
Data.s "OPEN1.WAV"
Data.s "CLOSE15.WAV"
Data.s "METAL14.WAV"
Data.s "DRIP6.WAV"
Data.s "IMPACT36.WAV"
Data.s "SWITCH04.WAV"
Data.s "CRUSH77.WAV"
Data.s "DOWN01.WAV"
Data.s "BATHOS.WAV"
Data.s "NEONBELL.WAV"
Data.s "THWACK02.WAV";EXIT
EndDataSection

; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 88
; FirstLine = 50
; Folding = ---