XIncludeFile "picking.pbi"
Procedure Normalise(*N.f_Vecteur)
  Define.f NormeVecteur
   
  NormeVecteur = NORME(*N)
  If NormeVecteur <> 0.0
    *N\x / NormeVecteur
    *N\y / NormeVecteur
    *N\z / NormeVecteur
  EndIf   
EndProcedure
Procedure P3D_P2D(*Mulot.s_Souris)
  Define.f_Vecteur p
  Define.f X1, Y1, Z1
  ;Position du point dans le repre de la camra
  p\x = *Mulot\Pos3D\x - CameraX(0)
  p\y = *Mulot\Pos3D\y - CameraY(0)
  p\z = *Mulot\Pos3D\z - CameraZ(0) 
  X1 = (MatriceCamera(0,0) * p\x) + (MatriceCamera(0,1) * p\y) + (MatriceCamera(0,2) * p\z)
  Y1 = (MatriceCamera(1,0) * p\x) + (MatriceCamera(1,1) * p\y) + (MatriceCamera(1,2) * p\z)
  Z1 = (MatriceCamera(2,0) * p\x) + (MatriceCamera(2,1) * p\y) + (MatriceCamera(2,2) * p\z)
  
  ; Transformation 3D --> 2D
  If Z1 <> 0 
    *Mulot\Pos2D\x = (X1 / Z1 * Screen\d) + Screen\Width_2 
    *Mulot\Pos2D\y = (Y1 / Z1 * Screen\d) + Screen\Height_2 
  Else ;  voir ?
    *Mulot\Pos2D\x = (X1 / Screen\d) + Screen\Width_2 
    *Mulot\Pos2D\y = (Y1 / Screen\d) + Screen\Height_2 
  EndIf     
EndProcedure  
 
Procedure P2D_P3D(*Mulot.s_Souris)
  Define.f X1, Y1, Z1
  
  CalculMatriceCamera()
  
  ;Conversion position souris en 3D
  X1 = (*Mulot\Pos2D\x - Screen\Width_2) 
  Y1 = (*Mulot\Pos2D\y - Screen\Height_2) 
  Z1 = Screen\d 

  ;Retour dans le repre de la scne
  *Mulot\Pos3D\x = (MatriceCamera(0,0) * X1) + (MatriceCamera(1,0) * Y1) + (MatriceCamera(2,0) * Z1)
  *Mulot\Pos3D\y = (MatriceCamera(0,1) * X1) + (MatriceCamera(1,1) * Y1) + (MatriceCamera(2,1) * Z1)
  *Mulot\Pos3D\z = (MatriceCamera(0,2) * X1) + (MatriceCamera(1,2) * Y1) + (MatriceCamera(2,2) * Z1) 
  *Mulot\Pos3D\x  + CameraX(0) 
  *Mulot\Pos3D\y  + CameraY(0) 
  *Mulot\Pos3D\z  + CameraZ(0) 
  
  ;Calcul le rayon passant par la souris
  ;Origine du rayon
  *Mulot\Rayon\Origine\x = CameraX(0)
  *Mulot\Rayon\Origine\y = CameraY(0)
  *Mulot\Rayon\Origine\z = CameraZ(0)
 
  ;Direction du rayon
  *Mulot\Rayon\Direction\x = *Mulot\Pos3D\x - CameraX(0)
  *Mulot\Rayon\Direction\y = *Mulot\Pos3D\y - CameraY(0)
  *Mulot\Rayon\Direction\z = *Mulot\Pos3D\z - CameraZ(0)
  
  Normalise(*Mulot\Rayon\Direction)
EndProcedure 

Procedure CalculMatriceCamera()
  Define.f_Vecteur x, y, z, p, SceneY

  SceneY\x = 0
  SceneY\y = 1
  SceneY\z = 0
 
  ;Calcule l'axe z de la camra 
  z\x = Camera\LookAt\x - CameraX(0)
  z\y = Camera\LookAt\y - CameraY(0)
  z\z = Camera\LookAt\z - CameraZ(0)

  Normalise(@z)

  ;Calcul l'axe x de la camra de faon  ce qu'il soit perpendulaire aux axes z et Y de la Scne
  PRODUIT_VECTORIEL(x, z, SceneY)
  Normalise(@x)
 
  ;Calcule l'axe Y de la camra de faon  ce qu'il soit perpendiculaire aux axes z et x
  PRODUIT_VECTORIEL(y, z, x)
  Normalise(@y)
 
  ;Ligne Colonne
  MatriceCamera(0,0) = x\x
  MatriceCamera(0,1) = x\y
  MatriceCamera(0,2) = x\z 
 
  MatriceCamera(1,0) = y\x
  MatriceCamera(1,1) = y\y
  MatriceCamera(1,2) = y\z 
 
  MatriceCamera(2,0) = z\x
  MatriceCamera(2,1) = z\y
  MatriceCamera(2,2) = z\z 
  
EndProcedure

Procedure IntersectionRayonPlan(*Rayon.s_Rayon, *Plan.s_Plan)
  Define.f_Vecteur PointCollision 
	Define.f PScalaireNormalePlanRayon, DistanceRayonPlan, t
  
  ;Calcul le produit scalaire Normale du plan avec le vecteur directeur du rayon
	PScalaireNormalePlanRayon = PRODUIT_SCALAIRE(*Plan\normale, *Rayon\Direction)
	   
	;Le rayon est parallle au plan
	If PScalaireNormalePlanRayon >= -#Epsilon And PScalaireNormalePlanRayon <= #Epsilon
	  ProcedureReturn #False
	EndIf
			   
  ;Calcul la distance du rayon au plan (d=N.S0+Cp : http://homeomath.imingo.net/displan.htm)
  DistanceRayonPlan = PRODUIT_SCALAIRE(*Rayon\Origine, *Plan\normale) + *Plan\Constante

	;Intersection avec le plan
  t = -DistanceRayonPlan / PScalaireNormalePlanRayon
   
  ;Pas de collision 
  If t < #Epsilon
    ProcedureReturn #False 
  EndIf
	   
  ;Point d'intersection avec le plan
  *Rayon\PointIntersection\x = (*Rayon\Origine\x + t * *Rayon\Direction\x)
  *Rayon\PointIntersection\y = (*Rayon\Origine\y + t * *Rayon\Direction\y)
  *Rayon\PointIntersection\z = (*Rayon\Origine\z + t * *Rayon\Direction\z) 
	     		     	
	;Collision
	*Rayon\CollisionDetectee = #True
EndProcedure

Procedure DrawBox(x.f,y.f,z.f,Width.f,Height.f,Coul)
    Dim Box3D.s_Souris(3)
    Box3D(0)\Pos3D\x=x
    Box3D(0)\Pos3D\y=y
    Box3D(0)\Pos3D\z=z    
    P3D_P2D(@Box3D(0))
    Box3D(1)\Pos3D\x=Box3D(0)\Pos3D\x+Width
    Box3D(1)\Pos3D\y=Box3D(0)\Pos3D\y
    Box3D(1)\Pos3D\z=Box3D(0)\Pos3D\z
    P3D_P2D(@Box3D(1))
    Box3D(2)\Pos3D\x=Box3D(0)\Pos3D\x+Width
    Box3D(2)\Pos3D\y=Box3D(0)\Pos3D\y
    Box3D(2)\Pos3D\z=Box3D(0)\Pos3D\z+Height
    P3D_P2D(@Box3D(2))
    Box3D(3)\Pos3D\x=Box3D(0)\Pos3D\x
    Box3D(3)\Pos3D\y=Box3D(0)\Pos3D\y
    Box3D(3)\Pos3D\z=Box3D(0)\Pos3D\z+Height
    P3D_P2D(@Box3D(3))   
    
    LineXY( Box3D(0)\Pos2D\x,Box3D(0)\Pos2D\y,Box3D(1)\Pos2D\x,Box3D(1)\Pos2D\y,Coul)
    LineXY( Box3D(1)\Pos2D\x,Box3D(1)\Pos2D\y,Box3D(2)\Pos2D\x,Box3D(2)\Pos2D\y,Coul)
    LineXY( Box3D(2)\Pos2D\x,Box3D(2)\Pos2D\y,Box3D(3)\Pos2D\x,Box3D(3)\Pos2D\y,Coul)
    LineXY( Box3D(3)\Pos2D\x,Box3D(3)\Pos2D\y,Box3D(0)\Pos2D\x,Box3D(0)\Pos2D\y,Coul)  
    
EndProcedure
Procedure Souris(*Map.s_Map,*Player.s_Player,*Plan.s_Plan)
  Dim P.s_Souris(3) ; Bloc slectionn
  Dim S.s_Souris(3) ; Switch slectionn
  Dim T.s_Souris(3) ; Limite du jeu
  
    ;Calcul le point 3D correspondant  la souris ainsi que le rayon passant par la souris
    Souris\Pos2D\x = WindowMouseX(0)-5
    Souris\Pos2D\y = WindowMouseY(0)-10
    P2D_P3D(@Souris)
    ;Calcul l'intersection sur le plan du jeu
    IntersectionRayonPlan(@Souris\Rayon, *Plan)
    ;Calcul la position sur la map
    *Map\Bloc\x=Souris\Rayon\PointIntersection\x/#Taille
    *Map\Bloc\z=Souris\Rayon\PointIntersection\z/#Taille
 
    StartDrawing(ScreenOutput())
      ;Switch slectionn
      If IndexArrayOk(*Map,*Map\SSwitch\x,*Map\SSwitch\z)
        DrawBox(*Map\SSwitch\x*#Taille-#Taille2,0,*Map\SSwitch\z*#Taille-#Taille2,#Taille,#Taille,$FF6666)
      EndIf
      ;Bloc slectionn pour tre activ par un switch
      If IndexArrayOk(*Map,*Map\SBloc\x,*Map\SBloc\z)
        DrawBox(*Map\SBloc\x*#Taille-#Taille2,0,*Map\SBloc\z*#Taille-#Taille2,#Taille,#Taille,$FFFFFF)
      EndIf
      ;Limites du terrain de jeu
      If *Map\SizeX Or *Map\SizeZ
        DrawBox(#Taille2,0,#Taille2,15*#Taille,10*#Taille,$66FF66)
      EndIf 
    StopDrawing()

EndProcedure
; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 74
; FirstLine = 44
; Folding = --