XIncludeFile "main.pbi"
XIncludeFile "Editeur.pbi"
InitGame()
XIncludeFile "3D.pb"
XIncludeFile "Map.pb"
XIncludeFile "Game.pb"
XIncludeFile "Windows.pb"
XIncludeFile "Picking.pb"

Main()
End

Procedure Main()
  Define Quit
  Define.s_Map Map
  Define.s_Player Player
  
  InitMesh()
  InitMaterial()
  InitNouveau(@Map) 
  UpdateTree(@Map) 
  InitPlayer(@Player)
  
  Repeat
    Event = WaitWindowEvent()
    UpdateStatusBar(@Map)
    HandleLButton(@Map,@Player)

    Select Event
      Case 0
        Delay(10)
      
      Case #PB_Event_CloseWindow
        Quit=#True
      
      Case #PB_Event_Menu
        Quit=HandleMenu(@Map,@Player)
                  
      Case #PB_Event_Gadget
        HandleGadget(@Map)   

      Case #WM_RBUTTONDOWN
        HandleRButtonDown(@Map)
        
    EndSelect
    RenderWorld() 
    Souris(@Map,@Player,@Plan)   
    FlipBuffers()
    RedrawWindow_(WindowID(0),0,0,#RDW_UPDATENOW)
  Until Quit
EndProcedure

Procedure InitGame()
  If InitEngine3D()=0 
    MessageRequester("Erreur", "Impossible d'initialiser le moteur 3D , vrifier la prsence de Engine3D.dll",0)
    End
  EndIf  
  If InitSprite()=0 Or InitSound()=0
    MessageRequester("Erreur", "Impossible d'initialiser DirectX",0)
    End
  EndIf
  If OpenWindow(0,0,0,1024,768,"Editeur PureBlock",#PB_Window_ScreenCentered|#PB_Window_SystemMenu)=0
    MessageRequester("Erreur", "Impossible d'ouvrir la fentre principale",0)
    End
  EndIf  
  CreateGadget()
  Add3DArchive("Textures",#PB_3DArchive_FileSystem)
  Add3DArchive("Textures\Skybox.zip", #PB_3DArchive_Zip)
EndProcedure

Procedure MessageErreur(Texte.s)
  CloseScreen()
  MessageRequester("Erreur", Texte, 0)
  End
EndProcedure 


; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 28
; FirstLine = 13
; Folding = -
; Executable = Editeur.exe
; DisableDebugger